## zeromq3 4.1.5+git20160811+2fc86bc

=== CMakeLists.txt ===
# CMake build script for ZeroMQ

cmake_minimum_required (VERSION 2.8.12)
project (ZeroMQ)

list (INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}")

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
endif()
include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG("-std=gnu11" COMPILER_SUPPORTS_C11)
if(COMPILER_SUPPORTS_C11)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
endif()

option (WITH_OPENPGM "Build with support for OpenPGM" OFF)
option (WITH_VMCI "Build with support for VMware VMCI socket" OFF)

if (APPLE)
    option (ZMQ_BUILD_FRAMEWORK "Build as OS X framework" ON)
endif ()

# Select curve encryption library, defaults to tweetnacl
# To use libsodium instead, use --with-libsodium (must be installed)
# To disable curve, use --disable-curve

option (WITH_LIBSODIUM "Use libsodium instead of built-in tweetnacl" OFF)
option (ENABLE_CURVE "Enable CURVE security" ON)

if (NOT ENABLE_CURVE)
    message (STATUS "CURVE security is disabled")

elseif (WITH_LIBSODIUM)
    find_package (Sodium)
    if (SODIUM_FOUND)
        message (STATUS "Using libsodium for CURVE security")
        include_directories (${SODIUM_INCLUDE_DIRS})

        # On Solaris, libsodium depends on libssp
        if (${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
            target_link_libraries (libzmq ssp)
        endif ()
        set (ZMQ_USE_LIBSODIUM 1)
        set (ZMQ_HAVE_CURVE 1)
    else ()
        message (FATAL_ERROR
            "libsodium is not installed. Install it, then run CMake again")
    endif ()

else ()
    message (STATUS "Using tweetnacl for CURVE security")
    list (APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/tweetnacl.c)
    set (ZMQ_USE_TWEETNACL 1)
    set (ZMQ_HAVE_CURVE 1)
endif ()

set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

if (EXISTS "${SOURCE_DIR}/.git")
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" ON)
else ()
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
endif ()
IF (ENABLE_DRAFTS)
    ADD_DEFINITIONS (-DZMQ_BUILD_DRAFT_API)
    set (pkg_config_defines "-DZMQ_BUILD_DRAFT_API=1")
ELSE (ENABLE_DRAFTS)
    set (pkg_config_defines "")
ENDIF (ENABLE_DRAFTS)

option (WITH_MILITANT "Enable militant assertions" OFF)
if (WITH_MILITANT)
    add_definitions(-DZMQ_ACT_MILITANT)
endif()

set (POLLER "" CACHE STRING "Choose polling system. valid values are
                            kqueue, epoll, devpoll, poll or select [default=autodetect]")

include (CheckFunctionExists)
include (CheckTypeSize)

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/event.h)
    check_function_exists (kqueue HAVE_KQUEUE)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_KQUEUE)
        set (POLLER "kqueue")
    endif()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/epoll.h)
    check_function_exists (epoll_create HAVE_EPOLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_EPOLL)
        set (POLLER "epoll")
    endif ()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES sys/devpoll.h)
    check_type_size ("struct pollfd" DEVPOLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_DEVPOLL)
        set (POLLER "devpoll")
    endif ()
endif ()

if (POLLER STREQUAL "")
    set (CMAKE_REQUIRED_INCLUDES poll.h)
    check_function_exists (poll HAVE_POLL)
    set (CMAKE_REQUIRED_INCLUDES)
    if (HAVE_POLL)
        set (POLLER "poll")
    endif ()
endif ()

if (POLLER STREQUAL "")
    if (WIN32)
        set (CMAKE_REQUIRED_INCLUDES winsock2.h)
        set (HAVE_SELECT 1)
    else ()
        set (CMAKE_REQUIRED_INCLUDES sys/select.h)
        check_function_exists (select HAVE_SELECT)
        set (CMAKE_REQUIRED_INCLUDES)
    endif ()
    if (HAVE_SELECT)
        set (POLLER "select")
    else ()
        message (FATAL_ERROR
            "Could not autodetect polling method")
    endif ()
endif ()

if (POLLER STREQUAL "kqueue"
 OR POLLER STREQUAL "epoll"
 OR POLLER STREQUAL "devpoll"
 OR POLLER STREQUAL "poll"
 OR POLLER STREQUAL "select")
    message (STATUS "Detected ${POLLER} polling method")
    string (TOUPPER ${POLLER} UPPER_POLLER)
    set (ZMQ_USE_${UPPER_POLLER} 1)
else ()
    message (FATAL_ERROR "Invalid polling method")
endif ()

set (ZMQ_CMAKE_MODULES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/builds/cmake/Modules)
list (APPEND CMAKE_MODULE_PATH ${ZMQ_CMAKE_MODULES_DIR})

include (TestZMQVersion)
include (ZMQSourceRunChecks)
include (CheckIncludeFiles)
include (CheckLibraryExists)
include (CheckCCompilerFlag)
include (CheckCXXCompilerFlag)
include (CheckCSourceCompiles)
include (CheckCSourceRuns)
include (CMakeDependentOption)
include (CheckCXXSymbolExists)

check_include_files (ifaddrs.h ZMQ_HAVE_IFADDRS)
check_include_files (windows.h ZMQ_HAVE_WINDOWS)
check_include_files (sys/uio.h ZMQ_HAVE_UIO)
check_include_files (sys/eventfd.h ZMQ_HAVE_EVENTFD)

check_library_exists (ws2_32 fopen "" HAVE_WS2_32) # TODO: Why doesn't something logical like WSAStartup work?
check_library_exists (ws2 fopen "" HAVE_WS2)
check_library_exists (rpcrt4 fopen "" HAVE_RPCRT4) # UuidCreateSequential
check_library_exists (iphlpapi fopen "" HAVE_IPHLAPI) # GetAdaptersAddresses

check_cxx_symbol_exists (SO_PEERCRED sys/socket.h ZMQ_HAVE_SO_PEERCRED)
check_cxx_symbol_exists (LOCAL_PEERCRED sys/socket.h ZMQ_HAVE_LOCAL_PEERCRED)

find_library (RT_LIBRARY rt)

find_package (Threads)


if (WIN32 AND NOT CYGWIN)
  if (NOT HAVE_WS2_32 AND NOT HAVE_WS2)
    message (FATAL_ERROR "Cannot link to ws2_32 or ws2")
  endif ()

  if (NOT HAVE_RPCRT4)
    message (FATAL_ERROR "Cannot link to rpcrt4")
  endif ()

  if (NOT HAVE_IPHLAPI)
    message (FATAL_ERROR "Cannot link to iphlapi")
  endif ()
endif ()

set (CMAKE_REQUIRED_LIBRARIES rt)
check_function_exists (clock_gettime HAVE_CLOCK_GETTIME)
set (CMAKE_REQUIRED_LIBRARIES)

set (CMAKE_REQUIRED_INCLUDES unistd.h)
check_function_exists (fork HAVE_FORK)
set (CMAKE_REQUIRED_INCLUDES)

set (CMAKE_REQUIRED_INCLUDES sys/time.h)
check_function_exists (gethrtime HAVE_GETHRTIME)
set (CMAKE_REQUIRED_INCLUDES)

set (CMAKE_REQUIRED_INCLUDES stdlib.h)
check_function_exists (mkdtemp HAVE_MKDTEMP)
set (CMAKE_REQUIRED_INCLUDES)

add_definitions (-D_REENTRANT -D_THREAD_SAFE)
add_definitions (-DZMQ_CUSTOM_PLATFORM_HPP)

option (ENABLE_EVENTFD "Enable/disable eventfd" ZMQ_HAVE_EVENTFD)

macro (zmq_check_cxx_flag_prepend flag)
  check_cxx_compiler_flag ("${flag}" HAVE_FLAG_${flag})

  if (HAVE_FLAG_${flag})
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
  endif ()
endmacro ()


if (MSVC)
  zmq_check_cxx_flag_prepend ("/W3")

  if (MSVC_IDE)
    set (MSVC_TOOLSET "-${CMAKE_VS_PLATFORM_TOOLSET}")
  else ()
    set (MSVC_TOOLSET "")
  endif ()
else ()
  zmq_check_cxx_flag_prepend ("-Wall")
endif ()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  zmq_check_cxx_flag_prepend ("-Wextra")
endif ()

#   TODO: why is -Wno-long-long defined differently than in configure.ac?
zmq_check_cxx_flag_prepend ("-Wno-long-long")
zmq_check_cxx_flag_prepend ("-Wno-uninitialized")

option (LIBZMQ_PEDANTIC "" ON)
option (LIBZMQ_WERROR "" OFF)

if (LIBZMQ_PEDANTIC)
  zmq_check_cxx_flag_prepend ("-pedantic")

  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Intel")
    zmq_check_cxx_flag_prepend ("-strict-ansi")
  endif ()

  if (${CMAKE_CXX_COMPILER_ID} MATCHES "SunPro")
    zmq_check_cxx_flag_prepend ("-compat=5")
  endif ()
endif ()

if (LIBZMQ_WERROR)
  zmq_check_cxx_flag_prepend ("-Werror")
  zmq_check_cxx_flag_prepend ("-errwarn=%all")
endif ()


if (CMAKE_SYSTEM_PROCESSOR MATCHES "^sparc")
  zmq_check_cxx_flag_prepend ("-mcpu=v9")
endif ()

if (${CMAKE_CXX_COMPILER_ID} MATCHES "SunPro")
  zmq_check_cxx_flag_prepend ("-features=zla")
endif ()


if (CMAKE_SYSTEM_NAME MATCHES "SunOS" OR CMAKE_SYSTEM_NAME MATCHES "NetBSD")
  message (STATUS "Checking whether atomic operations can be used")
  check_c_source_compiles (
  "
   #include <atomic.h>

    int main ()
    {
      uint32_t value;
      atomic_cas_32 (&value, 0, 0);
      return 0;
    }
    "
    HAVE_ATOMIC_H)

  if (NOT HAVE_ATOMIC_H)
    set (ZMQ_FORCE_MUTEXES 1)
  endif ()
endif ()


#-----------------------------------------------------------------------------
zmq_check_sock_cloexec ()
zmq_check_so_keepalive ()
zmq_check_tcp_keepcnt ()
zmq_check_tcp_keepidle ()
zmq_check_tcp_keepintvl ()
zmq_check_tcp_keepalive ()
zmq_check_tcp_tipc ()


if (    CMAKE_SYSTEM_NAME MATCHES "Linux"
    OR CMAKE_SYSTEM_NAME MATCHES "GNU/kFreeBSD"
    OR CMAKE_SYSTEM_NAME MATCHES "GNU/Hurd"
    OR CYGWIN)
  add_definitions (-D_GNU_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  add_definitions (-D__BSD_VISIBLE)
elseif (CMAKE_SYSTEM_NAME MATCHES "NetBSD")
  add_definitions (-D_NETBSD_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  add_definitions (-D_OPENBSD_SOURCE)
elseif (CMAKE_SYSTEM_NAME MATCHES "SunOS")
  add_definitions (-D_PTHREADS)
elseif (CMAKE_SYSTEM_NAME MATCHES "HP-UX")
  add_definitions (-D_POSIX_C_SOURCE=200112L)
  zmq_check_cxx_flag_prepend (-Ae)
elseif (CMAKE_SYSTEM_NAME MATCHES "Darwin")
  add_definitions (-D_DARWIN_C_SOURCE)
endif ()

set (CMAKE_PYTHON_VERSION 2.7 2.6 2.5 2.4)
find_package (PythonInterp)
find_package (AsciiDoc)

cmake_dependent_option (WITH_DOC "Build Reference Guide documentation (requires DocBook)" ON
                       "PYTHON_FOUND;ASCIIDOC_FOUND" OFF)

if (MSVC)
  if (WITH_OPENPGM)
    #   set (OPENPGM_ROOT "" CACHE PATH "Location of OpenPGM")
    set (OPENPGM_VERSION_MAJOR 5)
    set (OPENPGM_VERSION_MINOR 2)
    set (OPENPGM_VERSION_MICRO 122)
    if (CMAKE_CL_64)
      find_path (OPENPGM_ROOT include/pgm/pgm.h
                PATHS
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                NO_DEFAULT_PATH
               )
      message (STATUS "OpenPGM x64 detected - ${OPENPGM_ROOT}")
    else ()
      find_path (OPENPGM_ROOT include/pgm/pgm.h
                PATHS
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Wow6432Node\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Miru\\OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}]"
                NO_DEFAULT_PATH
               )
      message (STATUS "OpenPGM x86 detected - ${OPENPGM_ROOT}")
    endif (CMAKE_CL_64)
    set (OPENPGM_INCLUDE_DIRS ${OPENPGM_ROOT}/include)
    set (OPENPGM_LIBRARY_DIRS ${OPENPGM_ROOT}/lib)
    set (OPENPGM_LIBRARIES
      optimized libpgm${MSVC_TOOLSET}-mt-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib
      debug libpgm${MSVC_TOOLSET}-mt-gd-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.lib)
  endif ()
else ()
  if (WITH_OPENPGM)
    message (FATAL_ERROR "WITH_OPENPGM not implemented")
    # DSO symbol visibility for openpgm
    if (HAVE_FLAG_VISIBILITY_HIDDEN)

    elseif (HAVE_FLAG_LDSCOPE_HIDDEN)
    endif ()
  endif ()
endif ()


#-----------------------------------------------------------------------------
# force off-tree build

if (${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
message (FATAL_ERROR "CMake generation is not allowed within the source directory!
Remove the CMakeCache.txt file and try again from another folder, e.g.:

   rm CMakeCache.txt
   mkdir cmake-make
   cd cmake-make
   cmake ..
")
endif ()

#-----------------------------------------------------------------------------
# default to Release build

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  # CMAKE_BUILD_TYPE is not used for multi-configuration generators like Visual Studio/XCode
  # which instead use CMAKE_CONFIGURATION_TYPES
  set (CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif ()

=== tests/CMakeLists.txt ===
# CMake build script for ZeroMQ tests
cmake_minimum_required(VERSION "2.8.1")

# On Windows: solution file will be called tests.sln
PROJECT(tests)

set(tests
        test_ancillaries
        test_system
        test_pair_inproc
        test_pair_tcp
        test_reqrep_inproc
        test_reqrep_tcp
        test_hwm
        test_hwm_pubsub
        test_reqrep_device
        test_sub_forward
        test_invalid_rep
        test_msg_flags
        test_msg_ffn
        test_connect_resolve
        test_immediate
        test_last_endpoint
        test_term_endpoint
        test_router_mandatory
        test_probe_router
        test_stream
        test_stream_empty
        test_stream_disconnect
        test_disconnect_inproc
        test_unbind_inproc
        test_unbind_wildcard
        test_ctx_options
        test_ctx_destroy
        test_security_null
        test_security_plain
        test_security_curve
        test_iov
        test_spec_req
        test_spec_rep
        test_spec_dealer
        test_spec_router
        test_spec_pushpull
        test_req_correlate
        test_req_relaxed
        test_conflate
        test_inproc_connect
        test_issue_566
        test_shutdown_stress
        test_timeo
        test_many_sockets
        test_diffserv
        test_connect_rid
        test_xpub_nodrop
        test_pub_invert_matching
        test_setsockopt
        test_sockopt_hwm
        test_heartbeats
        test_atomics
        test_bind_src_address
        test_capabilities
        test_metadata
        test_router_handover
        test_srcfd
        test_stream_timeout
        test_xpub_manual
        test_xpub_welcome_msg
        test_base85
        test_sodium
)
if(NOT WIN32)
  list(APPEND tests
          test_monitor
          test_ipc_wildcard
          test_pair_ipc
          test_reqrep_ipc
          test_proxy
          test_proxy_single_socket
          test_proxy_terminate
          test_getsockopt_memset
          test_filter_ipc
          test_stream_exceeds_buffer
          test_router_mandatory_hwm
          test_use_fd_ipc
          test_use_fd_tcp
  )
  if(HAVE_FORK)
    list(APPEND tests test_fork)
  endif()
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    list(APPEND tests
          test_abstract_ipc
    )
    if(ZMQ_HAVE_TIPC)
      list(APPEND tests
            test_pair_tipc
            test_reqrep_device_tipc
            test_reqrep_tipc
            test_router_mandatory_tipc
            test_sub_forward_tipc
            test_connect_delay_tipc
            test_shutdown_stress_tipc
            test_term_endpoint_tipc
      )
    endif()
  endif()
endif()

if(WITH_VMCI)
  list(APPEND tests
          test_pair_vmci
          test_reqrep_vmci
  )
endif()


IF (ENABLE_DRAFTS)
    list(APPEND tests
        test_poller
        test_thread_safe
        test_client_server
        test_timers
        test_radio_dish
        test_udp
        test_scatter_gather
        test_dgram
    )
ENDIF (ENABLE_DRAFTS)

# add location of platform.hpp for Windows builds
if(WIN32)
    add_definitions(-DZMQ_CUSTOM_PLATFORM_HPP)
    add_definitions(-D_WINSOCK_DEPRECATED_NO_WARNINGS)
    include_directories(../builds/msvc)
    # Same name on 64bit systems
    link_libraries(Ws2_32.lib)
endif()

# add library and include dirs for all targets
link_libraries(libzmq)
include_directories("${CMAKE_SOURCE_DIR}/../include")

foreach(test ${tests})
  add_executable(${test} ${test}.cpp)
  if(WIN32)
    # This is the output for Debug dynamic builds on Visual Studio 6.0
    # You should provide the correct directory, don't know how to do it automatically
    find_path(LIBZMQ_PATH "libzmq.lib" PATHS "../bin/Win32/Debug/v120/dynamic")
    if(NOT ${LIBZMQ_PATH} STREQUAL "LIBZMQ_PATH-NOTFOUND")
        SET_TARGET_PROPERTIES( ${test} PROPERTIES LINK_FLAGS "/LIBPATH:${LIBZMQ_PATH}" )
    endif()
  else()
    # per-test directories not generated on OS X / Darwin
    if (NOT ${CMAKE_CXX_COMPILER_ID} MATCHES "Clang.*")
        link_directories(${test} PRIVATE "${CMAKE_SOURCE_DIR}/../lib")
    endif()
  endif()

  if(RT_LIBRARY)
    target_link_libraries(${test} ${RT_LIBRARY} )
  endif()
  if(WIN32)
    add_test(NAME ${test} WORKING_DIRECTORY ${LIBRARY_OUTPUT_PATH} COMMAND ${test})
  else()
    add_test(NAME ${test} COMMAND ${test})
  endif()
  set_tests_properties(${test} PROPERTIES TIMEOUT 10)
endforeach()

#Check whether all tests in the current folder are present
file(READ "${CMAKE_CURRENT_LIST_FILE}" CURRENT_LIST_FILE_CONTENT)
file(GLOB ALL_TEST_SOURCES "test_*.cpp")
foreach(TEST_SOURCE ${ALL_TEST_SOURCES})
  get_filename_component(TESTNAME "${TEST_SOURCE}" NAME_WE)
  string(REGEX MATCH "${TESTNAME}" MATCH_TESTNAME "${CURRENT_LIST_FILE_CONTENT}")
  if (NOT MATCH_TESTNAME)
    message(AUTHOR_WARNING "Test '${TESTNAME}' is not known to CTest.")
  endif()
endforeach()

## zeromq3 3.2.3+dfsg

=== debian/changelog ===
zeromq3 (3.2.3+dfsg-2~bpo60+1) squeeze-backports-sloppy; urgency=low

  * Rebuild for squeeze-backports-sloppy.
  * Removed multiarch install locations

 -- Joe Healy <joehealy@gmail.com>  Sun, 01 Sep 2013 20:42:11 +1000

zeromq3 (3.2.3+dfsg-2) unstable; urgency=low

  * Make test failures non-fatal on kfreebsd and s390/s390x

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 14 May 2013 15:42:02 +0200

zeromq3 (3.2.3+dfsg-1) unstable; urgency=low

  * New upstream release
    - Change connection failure test to use an invalid hostname
      (Closes: #705561)
  * Fix typo in libzmq3-dbg description (Closes: #696731)
  * Provide the zmq.hpp C++ header again (Closes: #697743)
  * Upload to unstable

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 03 May 2013 13:00:43 +0200

zeromq3 (3.2.2+dfsg-1) experimental; urgency=low

  * New upstream release (Closes: #694087)
  * Do not mangle upstream version anymore

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 24 Nov 2012 17:07:58 +0100

zeromq3 (3.2.1~rc2+dfsg-1) experimental; urgency=low

  * New upstream RC release (Closes: #690704)
  * Bump Standards-Version to 3.9.4 (no changes needed)

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 16 Oct 2012 19:49:30 +0200

zeromq3 (3.2.0~rc1+dfsg-1) experimental; urgency=low

  * New upstream RC release
  * Use repack.{local,stub} instead of get-orig-source rule
  * Add 01_fix-unused-variable-error.patch
  * Remove build dependency on uuid-dev (no more needed)
  * Add 02_check-ifdef-SO_NOSIGPIPE.patch to fix kfreebsd build
  * Add 03_fix-test_shutdown_stress-segfault.patch

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 12 Jun 2012 10:53:58 +0200

zeromq3 (3.1.0~beta+dfsg-2) experimental; urgency=low

  * libzmq3-dev Conflicts with libzmq-dev (Closes: #676160)

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 05 Jun 2012 09:29:58 +0200

zeromq3 (3.1.0~beta+dfsg-1) experimental; urgency=low

  * Initial ZeroMQ v3 packaging (Closes: #661503)
    - Update get-orig-source rule and watch file
    - Rename binary packages to new SONAME
    - Update Vcs-* headers too
    - Update copyright file

 -- Alessandro Ghedini <ghedo@debian.org>  Mon, 04 Jun 2012 21:21:09 +0200

zeromq (2.2.0+dfsg-2) unstable; urgency=low

  * Make -dev package Multi-Arch: same too (Closes: #674601)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 03 Jun 2012 13:29:40 +0200

zeromq (2.2.0+dfsg-1) unstable; urgency=low

  * New maintainer (Closes: #673619)
  * Repack upstream tarball to remove bundled openpgm tarball and xmlParser
    - Mangle dversion in watch file
  * Switch to short-form dh rules file
    - Use autotools-dev plugin
  * Bump debhelper compat level to 9
  * Update copyright file using Copyright-Format 1.0
  * Remove source options
  * Remove unused lintian overrides
  * Add Multi-Arch headers
    - Fix *.install files to use multi-arch paths
  * Vcs-* tags point to collab-maint repository
  * Fix short and long descriptions formatting
  * Ignore beta 3.x releases in watch file
  * Remove outdated and uselss README.Debian

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 22 May 2012 22:24:49 +0200

zeromq (2.2.0-1) unstable; urgency=low

  * [5661946] Imported Upstream version 2.2.0 (Closes: #672427)
  * [bbf467d] Bump Standards-Version to 3.9.3 with no changes
  * [0da0708] Add Vcs-Git and Vcs-Browser to debian/control

 -- Martin Lucina <martin@lucina.net>  Sun, 20 May 2012 11:27:32 +0200

zeromq (2.1.11-1) unstable; urgency=low

  * [4016b65] Imported Upstream version 2.1.11
  * [eaa74d0] Maintainer e-mail address changed
  * [9943256] Run testsuite during build (Closes: #655620)
  * [5ea0ff8] Remove unneeded libzmq.la from libzmq-dev (Closes: #633292)

 -- Martin Lucina <martin@lucina.net>  Mon, 23 Jan 2012 11:14:23 +0100

zeromq (2.1.10-1) unstable; urgency=low

  * New upstream version. 

 -- Martin Lucina <mato@kotelna.sk>  Mon, 03 Oct 2011 17:09:06 +0200

zeromq (2.1.9-1) unstable; urgency=low

  * New upstream version. 

 -- Martin Lucina <mato@kotelna.sk>  Thu, 08 Sep 2011 16:38:46 +0200

zeromq (2.1.7-1) unstable; urgency=low

  * New upstream version. (closes: #619374)
  * --with-system-pgm is now used instead of the embedded OpenPGM library. 
  * Added Debian watch file.

 -- Martin Lucina <mato@kotelna.sk>  Fri, 13 May 2011 12:43:09 +0200

zeromq (2.1.4-1) experimental; urgency=low

  * New upstream version.
  * OpenPGM re-enabled for amd64 and i386, still using embedded library.

 -- Martin Lucina <mato@kotelna.sk>  Thu, 07 Apr 2011 15:37:46 +0200

zeromq (2.1.3-1) experimental; urgency=low

  * New upstream version.
  * The zeromq-bin package has been removed, as upstream has removed the
    devices.
  * Temporarily disabled OpenPGM builds on i386 and amd64 due to changes in
    upstream OpenPGM intergration. 

 -- Martin Lucina <mato@kotelna.sk>  Mon, 28 Mar 2011 10:39:51 +0200

zeromq (2.0.10-1) unstable; urgency=low

  * New upstream version.
  * Upstream now uses DFSG-clean OpenPGM tarball, so dropping .dfsg from 
    the Debian version.

 -- Martin Lucina <mato@kotelna.sk>  Thu, 21 Oct 2010 16:21:20 +0200

zeromq (2.0.9.dfsg-1) unstable; urgency=medium

  * New upstream version. 
  * Move all manpages in libzmq0 to zeromq-dev package (closes: #595890) 
  * Updated to standards version 3.9.1.
  * Add lintian-overrides for spelling-error-in-copyright due to error in
    upstream license of xmlParser.
  * Use Breaks: instead of Conflicts: in zeromq-bin package, fixes 
    conflicts-with-version from lintian.
  * Various other minor fixes for warnings from lintian.

 -- Martin Lucina <mato@kotelna.sk>  Wed, 08 Sep 2010 15:25:45 +0200

zeromq (2.0.7.dfsg-1) unstable; urgency=low

  * New upstream version.
  * Reformatted package description, thanks to Rhonda (closes: #577549)
  * Added AUTHORS, NEWS and README to installed documentation.
  * New maintainer (closes: #587505)

 -- Martin Lucina <mato@kotelna.sk>  Wed, 30 Jun 2010 12:31:08 +0200

zeromq (2.0.6beta.dfsg-2) unstable; urgency=low



=== debian/control ===
Source: zeromq3
Section: libs
Priority: optional
Maintainer: Alessandro Ghedini <ghedo@debian.org>
Uploaders: Joe Healy <joehealy@gmail.com>
Build-Depends: debhelper (>= 9),
 autotools-dev,
 libpgm-dev,
 pkg-config
Standards-Version: 3.9.4
Vcs-Browser: http://git.debian.org/?p=collab-maint/zeromq3.git
Vcs-Git: git://git.debian.org/collab-maint/zeromq3.git
Homepage: http://www.zeromq.org/

Package: libzmq3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: lightweight messaging kernel (shared library)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the libzmq shared library.

Package: libzmq3-dev
Architecture: any
Section: libdevel
Depends: libzmq3 (= ${binary:Version}), ${misc:Depends}
Conflicts: libzmq-dev
Multi-Arch: same
Description: lightweight messaging kernel (development files)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ development libraries and header files.

Package: libzmq3-dbg
Architecture: any
Priority: extra
Section: debug
Depends: libzmq3 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: lightweight messaging kernel (debugging symbols)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the debugging symbols for the ZeroMQ library.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
	DO_TEST = no
endif

ifeq ($(DEB_BUILD_ARCH_CPU), s390)
	DO_TEST = no
endif

ifeq ($(DEB_BUILD_ARCH_CPU), s390x)
	DO_TEST = no
endif

%:
	dh $@ --with=autotools-dev

override_dh_auto_configure:
	dh_auto_configure -- --with-system-pgm

override_dh_auto_test:
ifneq ($(DO_TEST), no)
	dh_auto_test
else
	-dh_auto_test
endif

override_dh_strip:
	dh_strip --dbg-package=libzmq3-dbg

=== debian/watch ===
version=3
options=dversionmangle=s/\+dfsg// \
http://download.zeromq.org/zeromq-(3.*)\.tar\.gz \
debian sh debian/repack.stub

## zeromq3 3.2.4+dfsg

=== debian/changelog ===
zeromq3 (3.2.4+dfsg-1) unstable; urgency=low

  * New upstream release
  * Update the zmq.hpp C++ header

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 20 Sep 2013 13:56:16 +0200

## zeromq3 4.0.4+dfsg

=== debian/changelog ===
zeromq3 (4.0.4+dfsg-2ubuntu0.1) trusty-security; urgency=medium

  * SECURITY UPDATE: man-in-the-middle attackers to conduct
    downgrade attacks via a crafted connection request.
    - debian/patches/CVE-2014-7202.patch: Solution: accept only the
      mechanism defined by the socket options.
    - CVE-2014-7202

  * SECURITY UPDATE: man-in-the-middle attackers to conduct replay
    attacks via unspecified vectors.
    - debian/patches/CVE-2014-7203.patch: Solution: ensure message
      short nonces are strictly increasing and validate them.
    - CVE-2014-7203

  * SECURITY UPDATE: remote attackers to conduct downgrade attacks
    and bypass ZMTP v3 protocol security mechanisms via a ZMTP v2
    or earlier header.
    - debian/patches/CVE-2014-9721.patch: Solution: if security is
      defined on a socket, reject all V2 and earlier connections,
      unconditionally.
    - CVE-2014-9721

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Tue, 07 Aug 2018 10:52:48 -0300

zeromq3 (4.0.4+dfsg-2) unstable; urgency=low

  * Honour nocheck option in DEB_BUILD_OPTIONS .
  * New maintainer (closes: #741746).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 20 Mar 2014 14:51:15 +0000

zeromq3 (4.0.4+dfsg-1) unstable; urgency=medium

  * QA upload; orphan the package
    - Upload to unstable
  * New upstream release
  * Update repack.stub script
  * Drop 02_fix-exported-symbols.patch and 03_fix-s390-rdtsc.patch
    (merged upstream)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 16 Mar 2014 14:02:28 +0100

zeromq3 (4.0.3+dfsg-1) experimental; urgency=medium

  * New upstream release (Closes: #736353)
  * Drop 01_shutdown-race.patch (merged upstream)
  * Update *.symbols file
  * Don't install README anymore
  * Update copyright file

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 05 Feb 2014 22:06:16 +0100

zeromq3 (3.2.4+dfsg-4) unstable; urgency=medium

  * Update Standards-Version to 3.9.5 (no changes needed)
  * Add 03_fix-s390-rdtsc.patch to fix FTBFS on s390x (Closes: #734521)
  * Re-enable tests on s390x

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 12 Jan 2014 13:21:34 +0100

zeromq3 (3.2.4+dfsg-3) unstable; urgency=medium

  * Do not export C++ symbols (Closes: #732654)
  * Use dh-autoreconf instead of autotools-dev

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 20 Dec 2013 19:11:09 +0100

zeromq3 (3.2.4+dfsg-2) unstable; urgency=medium

  * Fix vcs-field-not-canonical
  * Add symbols file
  * Add 01_shutdown-race.patch to fix a race condition on shutdown
    (Closes: #732576)

 -- Alessandro Ghedini <ghedo@debian.org>  Thu, 19 Dec 2013 13:42:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: zeromq3
 Section: libs
 Priority: optional
-Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Uploaders: Joe Healy <joehealy@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9),
- autotools-dev,
+ dh-autoreconf,
  libpgm-dev,
  pkg-config
-Standards-Version: 3.9.4
-Vcs-Browser: http://git.debian.org/?p=collab-maint/zeromq3.git
-Vcs-Git: git://git.debian.org/collab-maint/zeromq3.git
+Standards-Version: 3.9.5
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zeromq3.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/zeromq3.git
 Homepage: http://www.zeromq.org/
 
 Package: libzmq3

=== debian/watch ===
version=3
options=dversionmangle=s/\+dfsg// \
http://download.zeromq.org/zeromq-(4.*)\.tar\.gz \
debian sh debian/repack.stub

## zeromq3 4.0.5+dfsg

=== debian/changelog ===
zeromq3 (4.0.5+dfsg-3ubuntu1~gcc5.1) wily; urgency=medium

  * No-change test rebuild for g++5 ABI transition

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 15 Jul 2015 16:29:38 +0000

zeromq3 (4.0.5+dfsg-3) unstable; urgency=high

  * V3 protocol handler vulnerable to downgrade attacks, use upstream
    backported fix for this issue (closes: #784366).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 05 May 2015 21:06:02 +0000

zeromq3 (4.0.5+dfsg-2) unstable; urgency=medium

  * Don't use test_security_curve to prevent FTBFS.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 23 Oct 2014 06:29:29 +0000

zeromq3 (4.0.5+dfsg-1) unstable; urgency=high

  * New upstream release with important fixes, including:
    - CVE-2014-7202 - stream_engine.cpp security can be downgraded,
    - CVE-2014-7203 - curve messages can be replayed.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 22 Oct 2014 15:07:39 +0000

zeromq3 (4.0.4+dfsg-3) unstable; urgency=medium

  * Build with libsodium for crypto support (closes: #744969).
  * Update Standards-Version to 3.9.6 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 20 Oct 2014 19:16:16 +0000

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,9 @@
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
  libpgm-dev,
+ libsodium-dev,
  pkg-config
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zeromq3.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/zeromq3.git
 Homepage: http://www.zeromq.org/

## zeromq3 4.1.4

=== debian/changelog ===
zeromq3 (4.1.4-7) unstable; urgency=medium

  * Switch back libzmq5-dev package name to libzmq3-dev for the transition
    (closes: #818187).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 14 Mar 2016 20:48:59 +0100

zeromq3 (4.1.4-6) unstable; urgency=low

  * Fix FTBFS with GCC 6 (closes: #812049).
  * Update kFreeBSD symbols.
  * Only conflict / replace the development package with the previous soname
    version.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 28 Feb 2016 16:26:56 +0100

zeromq3 (4.1.4-5) unstable; urgency=low

  * Update the zmq.hpp C++ header wrapper.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 24 Feb 2016 22:32:08 +0100

zeromq3 (4.1.4-4) unstable; urgency=low

  * Make self-test failures non-fatal and verbose (closes: #815494).
  * Keep rebuildable.

  [ Steven Chamberlain <steven@pyro.eu.org> ]
  * Fix kFreeBSD FTBFS (closes: #815495).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 22 Feb 2016 17:51:44 +0100

zeromq3 (4.1.4-3) unstable; urgency=low

  * Disable buildd failing tests.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 21 Feb 2016 13:46:33 +0100

zeromq3 (4.1.4-2) unstable; urgency=low

  * Upload to unstable.
  * Builds on Hurd (closes: #799235).
  * Update copyright file.
  * Update Standards-Version to 3.9.7 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 21 Feb 2016 09:13:38 +0100

zeromq3 (4.1.4-1) experimental; urgency=low

  * New upstream release (closes: #790839).
  * Use patch to Hurd build support.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 20 Jan 2016 18:58:46 +0100

zeromq3 (4.1.2-1) experimental; urgency=low

  * New upstream release (closes: #790839).
  * Library transition to version 5 of soname.
  * Update symbols for libzmq5 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 11 Jul 2015 11:00:09 +0000

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,18 @@
 Source: zeromq3
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
- libpgm-dev,
+ libpgm-dev (>= 5.2.122~dfsg),
  libsodium-dev,
  pkg-config
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zeromq3.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/zeromq3.git
 Homepage: http://www.zeromq.org/
 
-Package: libzmq3
+Package: libzmq5
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -31,8 +30,10 @@
 Package: libzmq3-dev
 Architecture: any
 Section: libdevel
-Depends: libzmq3 (= ${binary:Version}), ${misc:Depends}
-Conflicts: libzmq-dev
+Depends: libzmq5 (= ${binary:Version}), ${misc:Depends}
+Conflicts: libzmq-dev, libzmq5-dev
+Replaces: libzmq5-dev
+Provides: libzmq5-dev
 Multi-Arch: same
 Description: lightweight messaging kernel (development files)
  ØMQ is a library which extends the standard socket interfaces with features
@@ -44,11 +45,11 @@
  .
  This package contains the ZeroMQ development libraries and header files.
 
-Package: libzmq3-dbg
+Package: libzmq5-dbg
 Architecture: any
 Priority: extra
 Section: debug
-Depends: libzmq3 (= ${binary:Version}), ${misc:Depends}
+Depends: libzmq5 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: lightweight messaging kernel (debugging symbols)
  ØMQ is a library which extends the standard socket interfaces with features

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export TEST_VERBOSE=1

ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
	DO_TEST = no
endif

override_dh_clean:
	dh_clean
	find $(CURDIR) -type s -exec rm {} \;
	rm -f config.log

override_dh_auto_configure:
	dh_auto_configure -- --with-system-pgm

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(DO_TEST), no)
	-dh_auto_test -- VERBOSE=1
else
	-dh_auto_test -- VERBOSE=1
endif
endif

override_dh_strip:
	dh_strip --dbg-package=libzmq5-dbg

%:
	dh $@ --with=autoreconf --parallel

.PHONY: override_dh_auto_configure override_dh_strip

## zeromq3 4.1.5+git20160811+2fc86bc

=== debian/changelog ===
zeromq3 (4.1.5+git20160811+2fc86bc-0ubuntu2) yakkety; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * New upstream snapshot based release (2fc86bc) (LP: #1612240)
  * debian/libzmq5.symbols:
    - Update to include the new exported symbols
  * debian/patches/*:
    - Refresh patches, removed no longer needed sys_ucred_h.patch and
      hurd-support_4.1.5.patch
  * debian/copyright:
    - Updated copyright contents
  * debian/patches/no-hardcoded-port-in-tests.patch:
    - Refresh to the snapshot release of zeromq

  [ Steve Langasek ]
  * Enforce the test suite instead of ignoring test failures, as requested
    by the MIR Team (#1597439)
  * debian/patches/no-hardcoded-port-in-tests.patch: never use hard-
    coded local port numbers in tests.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 21 Sep 2016 12:32:23 +0200

zeromq3 (4.1.5-2) unstable; urgency=low

  * Use Sodium crypto library for CURVE security (closes: #827830).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 27 Jun 2016 19:19:12 +0000

zeromq3 (4.1.5-1) unstable; urgency=low

  * New upstream release.
  * Drop gcc6-fix.patch as this release contains it.
  * Update Hurd support patch.
  * Update watch file (closes: #827526).
  * Update Standards-Version to 3.9.8 .
  * Keep rebuildable.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 18 Jun 2016 09:43:48 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: zeromq3
 Section: libs
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
  libpgm-dev (>= 5.2.122~dfsg),
  libsodium-dev,
  pkg-config
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zeromq3.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/zeromq3.git
 Homepage: http://www.zeromq.org/

## zeromq3 4.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,9 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
 endif()
 
+# Will be used to add flags to pkg-config useful when apps want to statically link
+set (pkg_config_libs_private "")
+
 option (WITH_OPENPGM "Build with support for OpenPGM" OFF)
 option (WITH_VMCI "Build with support for VMware VMCI socket" OFF)
 
@@ -45,6 +48,7 @@
         endif ()
         set (ZMQ_USE_LIBSODIUM 1)
         set (ZMQ_HAVE_CURVE 1)
+        set (pkg_config_libs_private "${pkg_config_libs_private} -lsodium")
     else ()
         message (FATAL_ERROR
             "libsodium is not installed. Install it, then run CMake again")
@@ -77,7 +81,7 @@
 endif()
 
 set (POLLER "" CACHE STRING "Choose polling system. valid values are
-                            kqueue, epoll, devpoll, poll or select [default=autodetect]")
+                            kqueue, epoll, devpoll, pollset, poll or select [default=autodetect]")
 
 include (CheckFunctionExists)
 include (CheckTypeSize)
@@ -97,6 +101,10 @@
     set (CMAKE_REQUIRED_INCLUDES)
     if (HAVE_EPOLL)
         set (POLLER "epoll")
+        check_function_exists (epoll_create1 HAVE_EPOLL_CLOEXEC)
+        if (HAVE_EPOLL_CLOEXEC)
+            set (ZMQ_USE_EPOLL_CLOEXEC 1)
+        endif ()
     endif ()
 endif ()
 
@@ -107,6 +115,15 @@
     if (HAVE_DEVPOLL)
         set (POLLER "devpoll")
     endif ()
+endif ()
+
+if (POLLER STREQUAL "")
+    set (CMAKE_REQUIRED_INCLUDES sys/pollset.h)
+    check_function_exists (pollset_create HAVE_POLLSET)
+    set (CMAKE_REQUIRED_INCLUDES)
+    if (HAVE_POLLSET)
+        set (POLLER "pollset")
+    endif()
 endif ()
 
 if (POLLER STREQUAL "")
@@ -138,6 +155,7 @@
 if (POLLER STREQUAL "kqueue"
  OR POLLER STREQUAL "epoll"
  OR POLLER STREQUAL "devpoll"
+ OR POLLER STREQUAL "pollset"
  OR POLLER STREQUAL "poll"
  OR POLLER STREQUAL "select")
     message (STATUS "Detected ${POLLER} polling method")
@@ -165,6 +183,9 @@
 check_include_files (windows.h ZMQ_HAVE_WINDOWS)
 check_include_files (sys/uio.h ZMQ_HAVE_UIO)
 check_include_files (sys/eventfd.h ZMQ_HAVE_EVENTFD)
+if (ZMQ_HAVE_EVENTFD)
+  zmq_check_efd_cloexec ()
+endif ()
 
 check_library_exists (ws2_32 fopen "" HAVE_WS2_32) # TODO: Why doesn't something logical like WSAStartup work?
 check_library_exists (ws2 fopen "" HAVE_WS2)
@@ -329,7 +350,7 @@
 find_package (AsciiDoc)
 
 cmake_dependent_option (WITH_DOC "Build Reference Guide documentation (requires DocBook)" ON
-                       "PYTHON_FOUND;ASCIIDOC_FOUND" OFF)
+                       "PYTHONINTERP_FOUND;ASCIIDOC_FOUND" OFF)
 
 if (MSVC)
   if (WITH_OPENPGM)
@@ -361,38 +382,14 @@
   endif ()
 else ()
   if (WITH_OPENPGM)
-    message (FATAL_ERROR "WITH_OPENPGM not implemented")
-    # DSO symbol visibility for openpgm
-    if (HAVE_FLAG_VISIBILITY_HIDDEN)
-
-    elseif (HAVE_FLAG_LDSCOPE_HIDDEN)
-    endif ()
-  endif ()
-endif ()
-
-
-#-----------------------------------------------------------------------------
-# force off-tree build
-
-if (${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
-message (FATAL_ERROR "CMake generation is not allowed within the source directory!
-Remove the CMakeCache.txt file and try again from another folder, e.g.:
-
-   rm CMakeCache.txt
-   mkdir cmake-make
-   cd cmake-make
-   cmake ..
-")
-endif ()
-
-#-----------------------------------------------------------------------------
-# default to Release build
-
-if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
-  # CMAKE_BUILD_TYPE is not used for multi-configuration generators like Visual Studio/XCode
-  # which instead use CMAKE_CONFIGURATION_TYPES
-  set (CMAKE_BUILD_TYPE Release CACHE STRING
-      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
-      FORCE)
-endif ()
-
+    #  message (FATAL_ERROR "WITH_OPENPGM not implemented")
+    
+    if (NOT OPENPGM_PKGCONFIG_NAME)
+      SET (OPENPGM_PKGCONFIG_NAME "openpgm-5.2")
+    endif(NOT OPENPGM_PKGCONFIG_NAME)
+    
+    SET (OPENPGM_PKGCONFIG_NAME ${OPENPGM_PKGCONFIG_NAME} CACHE STRING 
+      "Name pkg-config shall use to find openpgm libraries and include paths"
+      FORCE )
+    
+    find_package(PkgConfig)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -66,6 +66,7 @@
         test_xpub_manual
         test_xpub_welcome_msg
         test_base85
+        test_bind_after_connect_tcp
         test_sodium
 )
 if(NOT WIN32)
@@ -83,6 +84,7 @@
           test_router_mandatory_hwm
           test_use_fd_ipc
           test_use_fd_tcp
+          test_zmq_poll_fd
   )
   if(HAVE_FORK)
     list(APPEND tests test_fork)
@@ -137,7 +139,7 @@
 endif()
 
 # add library and include dirs for all targets
-link_libraries(libzmq)
+link_libraries(libzmq ${OPTIONAL_LIBRARIES})
 include_directories("${CMAKE_SOURCE_DIR}/../include")
 
 foreach(test ${tests})
@@ -155,6 +157,7 @@
         link_directories(${test} PRIVATE "${CMAKE_SOURCE_DIR}/../lib")
     endif()
   endif()
+
 
   if(RT_LIBRARY)
     target_link_libraries(${test} ${RT_LIBRARY} )

=== debian/changelog ===
zeromq3 (4.2.1-4+deb9u4) stretch-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * CVE-2021-20234
    Memory leak in client induced by malicious server without CURVE/ZAP
  * CVE-2021-20235
    Heap overflow when receiving malformed ZMTP v1 packets

 -- Anton Gladky <gladk@debian.org>  Tue, 09 Mar 2021 19:45:32 +0100

zeromq3 (4.2.1-4+deb9u3) stretch-security; urgency=high

  * Non-maintainer upload by the LTS team.
  * zeromq connects peer before handshake is completed.
    (CVE-2020-15166)

 -- Utkarsh Gupta <utkarsh@debian.org>  Tue, 10 Nov 2020 19:39:03 +0530

zeromq3 (4.2.1-4+deb9u2) stretch-security; urgency=high

  [ Luca Boccassi <bluca@debian.org> ]
  * Fix CVE-2019-13132: application metadata not parsed correctly when using
    CURVE.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 06 Jul 2019 14:19:32 +0000

zeromq3 (4.2.1-4+deb9u1) stretch-security; urgency=medium

  * CVE-2019-6250 (Closes: #919098)

 -- Moritz Mühlenhoff <jmm@debian.org>  Sun, 13 Jan 2019 18:02:22 +0100

zeromq3 (4.2.1-4) unstable; urgency=medium

  * Backport upstream fix to disable experimental zmq_poll implementation
    (closes: #861416).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 28 Apr 2017 18:52:42 +0000

zeromq3 (4.2.1-3) unstable; urgency=medium

  * Compile with OpenPGM support (closes: #856023).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 24 Feb 2017 17:35:03 +0000

zeromq3 (4.2.1-2) unstable; urgency=low

  * Backport upstream fix for Hurd FTBFS (closes: #849860).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 01 Jan 2017 15:53:54 +0000

zeromq3 (4.2.1-1) unstable; urgency=low

  * New upstream, bugfix release.
  * Sync with Ubuntu.

  [ Steve Langasek <steve.langasek@ubuntu.com> ]
  * Never use hard-coded local port numbers in tests.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 31 Dec 2016 16:03:21 +0000

zeromq3 (4.2.0-2) unstable; urgency=low

  * Update library symbols for kfreebsd-i386 .
  * Add xmlto and asciidoc to build depends to generate manpages
    (closes: #844104).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 12 Nov 2016 23:13:55 +0000

zeromq3 (4.2.0-1) unstable; urgency=low

  * New upstream release (closes: #843157).
  * Update library symbols.
  * Drop merged in patches.
  * Update remaining patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 04 Nov 2016 15:30:31 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: zeromq3
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9),
  dh-autoreconf,
  libpgm-dev (>= 5.2.122~dfsg),
  libsodium-dev,
- pkg-config
+ pkg-config,
+ xmlto,
+ asciidoc
 Standards-Version: 3.9.8
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zeromq3.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/zeromq3.git

=== debian/rules ===
--- 
+++ 
@@ -13,10 +13,11 @@
 override_dh_clean:
 	dh_clean
 	find $(CURDIR) -type s -exec rm {} \;
+	rm -f $(CURDIR)/doc/*.xml $(CURDIR)/doc/*.3 $(CURDIR)/doc/*.7
 	rm -f config.log
 
 override_dh_auto_configure:
-	dh_auto_configure -- --with-system-pgm
+	dh_auto_configure -- --with-pgm --with-libsodium
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

=== debian/watch ===
version=3
https://github.com/zeromq/zeromq4-1/releases .*/v\d.+/zeromq-([\d\.]+)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
